import-module -name SQLPS
cls
Write-Host "Export Days Enrolled, Present, Absent, ATT Percentage, and Tardies for a custom date range"
Write-Host "NOTE: ENR should hoepfully be accurate or you may need to ""Fix ENR"" first"
$DB = "DST16000AeriesDemo_ID"
$Servername = "YourSQLServerName"
$OutPath = "c:\Queryout"

$response = Read-host "Since When?"
$SinceWhen = $response

$response = Read-host "Until When?"
$UntilWhen = $response

$response = Read-host "What School Number?"
$sc = $response

$ServerIP = [System.Net.Dns]::GetHostAddresses("$Servername")  #This looks up IP in DNS and is more resilient than using a static IP
#$ServerIP = "127.0.0.1"

$response = Read-host "What's your SQL User Name?" -AsSecureString
$user = [Runtime.InteropServices.Marshal]::PtrToStringAuto([Runtime.InteropServices.Marshal]::SecureStringToBSTR($response))

$response = Read-host "What's your password?" -AsSecureString
$pass = [Runtime.InteropServices.Marshal]::PtrToStringAuto([Runtime.InteropServices.Marshal]::SecureStringToBSTR($response))


Invoke-Sqlcmd -serverinstance tcp:$ServerIP -QueryTimeout 600 -database $DB -username "$User" -password $Pass -query "



--Days Enrolled, Days Present, Days Absent, ATT percentage, and tardies aggregated by school this DB year with custom date range at top
--Now Honors Tracks!

declare @SinceWhen as datetime
declare @TillWhen as datetime
set @SinceWhen = '$SinceWhen'
set @TillWhen = '$UntilWhen'


;
--Unpivotted Tracks from DAY in a CTE called tdays

with tdays (SC, DY, DT, AB, BL, Track, HO)
as (
select SC, DY, DT, AB, BL, left(TrackHO,1) Track, substring(TrackHO,2,1) as HO
from
(
select SC, DY, DT, AB, HO, BL,TrackHO
from
(SELECT        SC, DY, DT, AB, HO, BL,
'A'+T1 as T1, 
'B'+T2 as T2, 
'C'+T3 as T3, 
'D'+T4 as T4, 
'E'+T5 as T5, 
'F'+T6 as T6, 
'G'+T7 as T7, 
'H'+T8 as T8, 
'I'+T9 as T9, 
'J'+T10 as T10, 
'K'+T11 as T11, 
'L'+T12 as T12, 
'M'+T13 as T13, 
'N'+T14 as T14, 
'O'+T15 as T15, 
'P'+T16 as T16, 
'Q'+T17 as T17, 
'R'+T18 as T18, 
'S'+T19 as T19, 
'T'+T20 as T20, 
'U'+T21 as T21, 
'V'+T22 as T22, 
'W'+T23 as T23, 
'X'+T24 as T24, 
'Y'+T25 as T25, 
'Z'+T26 as T26
from day WHERE DEL = 0) pvt
unpivot
( TrackHO for Tracks in (T1, T2, T3, T4, T5, T6, T7, T8, T9, T10, T11, T12, T13, T14, T15, T16, T17, T18, T19, T20, T21, T22, T23, T24, T25, T26)) as unpiv

union

select SC, DY, DT, AB, HO, BL, ' ' + HO AS TrackHO from day where DEL = 0
) trackdays
)




select SC, ID, SN, LN, FN, YR, [days Enrolled], [days Enrolled] - [days Absent] as [days Present], [days Absent], 
case when [days Enrolled] <> 0 then cast(cast( ([days Enrolled] - [days Absent]) / cast([days Enrolled] as dec(10,3)) * 100 as float) as varchar(50)) + '%' 
else '' end as ATTPercentage,
Tardies from 
(
select SC, ID, SN, LN, FN, YR, sum([days Enrolled]) as [days Enrolled], sum([days Absent]) as [days Absent], sum(Tardies) as Tardies from 
(select 
stu.sc, stu.id, stu.sn, stu.ln, stu.fn,
enr.yr, enr.pr, enr.ED, enr.LD,


(select count(*) from tdays inner join enr as enr2 on tdays.dt >= enr2.ed
where ho not in ('@','#','$','*')  
and enr2.sc = [tdays].sc
and [tdays].sc = stu.sc
and enr2.id = stu.id
and enr2.yr = '20' + substring(db_name(),4,2)
and [tdays].dt <= @TillWhen
and [tdays].dt >= @SinceWhen
and [tdays].dt <= case when enr2.ld is not null then enr2.ld else @TillWhen end
and enr2.del = 0 
and [tdays].dt >= enr.ed and [tdays].dt <= (case when enr.ld is not null then enr.ld else [tdays].dt end)
and enr2.sc = stu.sc
and tdays.track = stu.tr
) as [days Enrolled],

(select count(*) from att where del = 0 and al in (select cd from [abs] where del = 0 and sc = stu.sc and ad <> 1) and sc = stu.sc and sn = stu.sn and att.dt >= enr.ed and att.dt <= (case when enr.ld is not null then enr.ld else att.dt end) and att.dt <= @TillWhen and att.dt >= @SinceWhen and att.dt in (select dt from tdays where ho not in ('@','#','$','*') and tdays.track = (select tr from stu where sc = att.sc and sn = att.sn))) as [days Absent],

(select count(*) from att where AL in (select cd from [abs] where ty in (5,8,9) and del = 0 and sc = att.sc) and del = 0 and sc = stu.sc and sn = stu.sn and att.dt >= enr.ed and att.dt <= (case when enr.ld is not null then enr.ld else att.dt end) and att.dt <= @TillWhen and att.dt >= @SinceWhen and att.dt in (select dt from tdays where ho not in ('@','#','$','*') and tdays.track = (select tr from stu where sc = att.sc and sn = att.sn))) + 
(select count(*) from att where a0 in (select cd from [abs] where ty in (5,8,9) and del = 0 and sc = att.sc) and del = 0 and sc = stu.sc and sn = stu.sn and att.dt >= enr.ed and att.dt <= (case when enr.ld is not null then enr.ld else att.dt end) and att.dt <= @TillWhen and att.dt >= @SinceWhen and att.dt in (select dt from tdays where ho not in ('@','#','$','*') and tdays.track = (select tr from stu where sc = att.sc and sn = att.sn))) + 
(select count(*) from att where a1 in (select cd from [abs] where ty in (5,8,9) and del = 0 and sc = att.sc) and del = 0 and sc = stu.sc and sn = stu.sn and att.dt >= enr.ed and att.dt <= (case when enr.ld is not null then enr.ld else att.dt end) and att.dt <= @TillWhen and att.dt >= @SinceWhen and att.dt in (select dt from tdays where ho not in ('@','#','$','*') and tdays.track = (select tr from stu where sc = att.sc and sn = att.sn))) + 
(select count(*) from att where a2 in (select cd from [abs] where ty in (5,8,9) and del = 0 and sc = att.sc) and del = 0 and sc = stu.sc and sn = stu.sn and att.dt >= enr.ed and att.dt <= (case when enr.ld is not null then enr.ld else att.dt end) and att.dt <= @TillWhen and att.dt >= @SinceWhen and att.dt in (select dt from tdays where ho not in ('@','#','$','*') and tdays.track = (select tr from stu where sc = att.sc and sn = att.sn))) + 
(select count(*) from att where a3 in (select cd from [abs] where ty in (5,8,9) and del = 0 and sc = att.sc) and del = 0 and sc = stu.sc and sn = stu.sn and att.dt >= enr.ed and att.dt <= (case when enr.ld is not null then enr.ld else att.dt end) and att.dt <= @TillWhen and att.dt >= @SinceWhen and att.dt in (select dt from tdays where ho not in ('@','#','$','*') and tdays.track = (select tr from stu where sc = att.sc and sn = att.sn))) + 
(select count(*) from att where a4 in (select cd from [abs] where ty in (5,8,9) and del = 0 and sc = att.sc) and del = 0 and sc = stu.sc and sn = stu.sn and att.dt >= enr.ed and att.dt <= (case when enr.ld is not null then enr.ld else att.dt end) and att.dt <= @TillWhen and att.dt >= @SinceWhen and att.dt in (select dt from tdays where ho not in ('@','#','$','*') and tdays.track = (select tr from stu where sc = att.sc and sn = att.sn))) + 
(select count(*) from att where a5 in (select cd from [abs] where ty in (5,8,9) and del = 0 and sc = att.sc) and del = 0 and sc = stu.sc and sn = stu.sn and att.dt >= enr.ed and att.dt <= (case when enr.ld is not null then enr.ld else att.dt end) and att.dt <= @TillWhen and att.dt >= @SinceWhen and att.dt in (select dt from tdays where ho not in ('@','#','$','*') and tdays.track = (select tr from stu where sc = att.sc and sn = att.sn))) + 
(select count(*) from att where a6 in (select cd from [abs] where ty in (5,8,9) and del = 0 and sc = att.sc) and del = 0 and sc = stu.sc and sn = stu.sn and att.dt >= enr.ed and att.dt <= (case when enr.ld is not null then enr.ld else att.dt end) and att.dt <= @TillWhen and att.dt >= @SinceWhen and att.dt in (select dt from tdays where ho not in ('@','#','$','*') and tdays.track = (select tr from stu where sc = att.sc and sn = att.sn))) + 
(select count(*) from att where a7 in (select cd from [abs] where ty in (5,8,9) and del = 0 and sc = att.sc) and del = 0 and sc = stu.sc and sn = stu.sn and att.dt >= enr.ed and att.dt <= (case when enr.ld is not null then enr.ld else att.dt end) and att.dt <= @TillWhen and att.dt >= @SinceWhen and att.dt in (select dt from tdays where ho not in ('@','#','$','*') and tdays.track = (select tr from stu where sc = att.sc and sn = att.sn))) + 
(select count(*) from att where a8 in (select cd from [abs] where ty in (5,8,9) and del = 0 and sc = att.sc) and del = 0 and sc = stu.sc and sn = stu.sn and att.dt >= enr.ed and att.dt <= (case when enr.ld is not null then enr.ld else att.dt end) and att.dt <= @TillWhen and att.dt >= @SinceWhen and att.dt in (select dt from tdays where ho not in ('@','#','$','*') and tdays.track = (select tr from stu where sc = att.sc and sn = att.sn))) + 
(select count(*) from att where a9 in (select cd from [abs] where ty in (5,8,9) and del = 0 and sc = att.sc) and del = 0 and sc = stu.sc and sn = stu.sn and att.dt >= enr.ed and att.dt <= (case when enr.ld is not null then enr.ld else att.dt end) and att.dt <= @TillWhen and att.dt >= @SinceWhen and att.dt in (select dt from tdays where ho not in ('@','#','$','*') and tdays.track = (select tr from stu where sc = att.sc and sn = att.sn))) as Tardies

from stu inner join enr on stu.id = enr.id and stu.sc = enr.sc
where right(enr.yr,2) = substring(db_name(),4,2)
and stu.del = 0 and enr.del = 0

) deda

WHERE [days Enrolled] > 0
and sc = $sc
group by SC, ID, SN, LN, FN, YR) dedpda

order by sc, ln, fn



" | Export-Csv $OutPath\ATT_PERCENTAGE.csv -NoTypeInformation

