import-module -name SQLPS
cls
Write-Host "Export Days Enrolled, Present, Absent, ATT Percentage, and Tardies for a custom date range"
Write-Host "NOTE: ENR should hoepfully be accurate or you may need to ""Fix ENR"" first"
$DB = "DST16000AeriesDemo_ID"
$Servername = "YourSQLServerName"
$OutPath = "c:\Queryout"

$response = Read-host "Since When?"
$SinceWhen = $response

$response = Read-host "Until When?"
$UntilWhen = $response

$response = Read-host "What School Number?"
$sc = $response

$ServerIP = [System.Net.Dns]::GetHostAddresses("$Servername")  #This looks up IP in DNS and is more resilient than using a static IP
#$ServerIP = "127.0.0.1"

$response = Read-host "What's your SQL User Name?" -AsSecureString
$user = [Runtime.InteropServices.Marshal]::PtrToStringAuto([Runtime.InteropServices.Marshal]::SecureStringToBSTR($response))

$response = Read-host "What's your password?" -AsSecureString
$pass = [Runtime.InteropServices.Marshal]::PtrToStringAuto([Runtime.InteropServices.Marshal]::SecureStringToBSTR($response))


Invoke-Sqlcmd -serverinstance tcp:$ServerIP -QueryTimeout 600 -database $DB -username "$User" -password $Pass -query "

declare @yr varchar(2)
declare @sinceWhen datetime
declare @UntilWhen datetime

set @yr = substring(db_name(),4,2)
set @sinceWhen = '$SinceWhen'
set @UntilWhen = '$UntilWhen'


select sc, sn, id, fn, ln, gr, sp, tg, sm, pd, co, te, dy, s1, dc, sum(Tardies) as Tardies, sum(Absences) as Absences, sum(EnrolledInCAR) as EnrolledInCAR, case when sum(EnrolledInCAR) > 0 then (sum(EnrolledInCAR) - sum(Absences)) / cast(sum(EnrolledInCAR) as dec(38,12)) *100 else null end as PresentPercent, case when sum(EnrolledInCAR) - sum(Absences) > 0 then (sum(EnrolledInCAR) - sum(Absences) - sum(Tardies)) / cast(sum(EnrolledInCAR) - sum(Absences) as dec(38,12)) *100 else null end as PunctualPercent
from (

select sc, sn, id, fn, ln, gr, sp, tg, sm, pd, co, te, dy, s1, dc, ds, de, Absences, Tardies, EnrolledInCAR, case when EnrolledInCAR > 0 then (EnrolledInCAR - Absences) / cast(EnrolledInCAR as dec(38,12)) *100 else null end as PerAttPerc
from 
(
select stu.sc, stu.sn, stu.id, stu.fn, stu.ln, stu.gr, stu.sp, stu.tg,
mst.sm, mst.pd, crs.co, tch.te, mst.dy, crs.s1, crs.dc, car.ds, car.de
,(select count(A0) from att where sc = stu.sc and sn = stu.sn and a0 in (select cd from abs where ad = 0 and del = 0 and sc = att.sc) and att.dt between car.ds and car.de
and dt in (select day.dt from day inner join enr on day.sc = enr.sc where right(enr.yr,2) = @yr and enr.sc = att.sc and enr.sn = att.sn and enr.del = 0 and day.del = 0 and dt between @SinceWhen and @UntilWhen and day.ho not in ('@','#','$'))
and dt in (
case 
when loc.ab = 1 and mst.dy = 'A-DAYS' then (select dt from day where ab = 'A' and dt = att.dt and sc = att.sc and del = 0) 
when loc.ab = 1 and mst.dy = 'B-DAYS' then (select dt from day where ab = 'B' and dt = att.dt and sc = att.sc and del = 0)
when (select bl from day where sc = att.sc and dt = att.dt) like (select '%'+ cast(car.pd as varchar(1)) + '%') then dt
when (select bl from day where sc = att.sc and dt = att.dt) = '' then dt
end)
and dt in (case when loc.ab = 0 then
case 
when mst.mm = 1 and datepart ( dw, dt ) = 2 then dt
when mst.mt = 1 and datepart ( dw, dt ) = 3 then dt
when mst.mw = 1 and datepart ( dw, dt ) = 4 then dt
when mst.mr = 1 and datepart ( dw, dt ) = 5 then dt
when mst.mf = 1 and datepart ( dw, dt ) = 6 then dt
else null end
else dt
end)
and dt between @SinceWhen and @UntilWhen) Absences
,(select count(A0) from att where sc = stu.sc and sn = stu.sn and a0 in (select cd from abs where ty in (5,8,9) and del = 0) and att.dt between car.ds and car.de
and dt in (select day.dt from day inner join enr on day.sc = enr.sc where right(enr.yr,2) = @yr and enr.sc = att.sc and enr.sn = att.sn and enr.del = 0 and day.del = 0 and dt between @SinceWhen and @UntilWhen and day.ho not in ('@','#','$'))
and dt in (
case 
when loc.ab = 1 and mst.dy = 'A-DAYS' then (select dt from day where ab = 'A' and dt = att.dt and sc = att.sc and del = 0) 
when loc.ab = 1 and mst.dy = 'B-DAYS' then (select dt from day where ab = 'B' and dt = att.dt and sc = att.sc and del = 0)
when (select bl from day where sc = att.sc and dt = att.dt) like (select '%'+ cast(car.pd as varchar(1)) + '%') then dt
when (select bl from day where sc = att.sc and dt = att.dt) = '' then dt
end)
and dt in (case when loc.ab = 0 then
case 
when mst.mm = 1 and datepart ( dw, dt ) = 2 then dt
when mst.mt = 1 and datepart ( dw, dt ) = 3 then dt
when mst.mw = 1 and datepart ( dw, dt ) = 4 then dt
when mst.mr = 1 and datepart ( dw, dt ) = 5 then dt
when mst.mf = 1 and datepart ( dw, dt ) = 6 then dt
else null end
else dt
end)
and dt between @SinceWhen and @UntilWhen) Tardies
,(select count(dt) from day where sc = car.sc and dt between car.ds and car.de and ho not in ('@','#','$') and del = 0
and dt in (
case 
when loc.ab = 1 and mst.dy = 'A-DAYS' then (select dt from day d where ab = 'A' and dt = day.dt and sc = car.sc and del = 0) 
when loc.ab = 1 and mst.dy = 'B-DAYS' then (select dt from day d where ab = 'B' and dt = day.dt and sc = car.sc and del = 0)
when (select bl from day d where sc = stu.sc and dt = day.dt) like (select '%'+ cast(car.pd as varchar(1)) + '%') then dt
when (select bl from day d where sc = stu.sc and dt = day.dt) = '' then dt
end)
and dt in (case when loc.ab = 0 then
case 
when mst.mm = 1 and datepart ( dw, dt ) = 2 then dt
when mst.mt = 1 and datepart ( dw, dt ) = 3 then dt
when mst.mw = 1 and datepart ( dw, dt ) = 4 then dt
when mst.mr = 1 and datepart ( dw, dt ) = 5 then dt
when mst.mf = 1 and datepart ( dw, dt ) = 6 then dt
else null end
else dt
end) and dt between @SinceWhen and @UntilWhen) EnrolledInCAR


from loc inner join stu on loc.cd = stu.sc
inner join car on stu.sc = car.sc and stu.sn = car.sn
inner join crs on car.cn = crs.cn
inner join tch on car.sc = tch.sc and car.tn = tch.tn
inner join mst on car.sc = mst.sc and car.se = mst.se

where loc.del = 0 and stu.del = 0 and car.del = 0 and mst.del = 0 and tch.del = 0
and loc.a = 1
and car.pd = 0
and car.ds <= @UntilWhen

union

select stu.sc, stu.sn, stu.id, stu.fn, stu.ln, stu.gr, stu.sp, stu.tg,
mst.sm, mst.pd, crs.co, tch.te, mst.dy, crs.s1, crs.dc, car.ds, car.de
,(select count(A1) from att where sc = stu.sc and sn = stu.sn and a1 in (select cd from abs where ad = 0 and del = 0 and sc = att.sc) and att.dt between car.ds and car.de
and dt in (select day.dt from day inner join enr on day.sc = enr.sc where right(enr.yr,2) = @yr and enr.sc = att.sc and enr.sn = att.sn and enr.del = 0 and day.del = 0 and dt between @SinceWhen and @UntilWhen and day.ho not in ('@','#','$'))
and dt in (
case 
when loc.ab = 1 and mst.dy = 'A-DAYS' then (select dt from day where ab = 'A' and dt = att.dt and sc = att.sc and del = 0) 
when loc.ab = 1 and mst.dy = 'B-DAYS' then (select dt from day where ab = 'B' and dt = att.dt and sc = att.sc and del = 0)
when (select bl from day where sc = att.sc and dt = att.dt) like (select '%'+ cast(car.pd as varchar(1)) + '%') then dt
when (select bl from day where sc = att.sc and dt = att.dt) = '' then dt
end)
and dt in (case when loc.ab = 0 then
case 
when mst.mm = 1 and datepart ( dw, dt ) = 2 then dt
when mst.mt = 1 and datepart ( dw, dt ) = 3 then dt
when mst.mw = 1 and datepart ( dw, dt ) = 4 then dt
when mst.mr = 1 and datepart ( dw, dt ) = 5 then dt
when mst.mf = 1 and datepart ( dw, dt ) = 6 then dt
else null end
else dt
end)
and dt between @SinceWhen and @UntilWhen) Absences
,(select count(A1) from att where sc = stu.sc and sn = stu.sn and a1 in (select cd from abs where ty in (5,8,9) and del = 0) and att.dt between car.ds and car.de
and dt in (select day.dt from day inner join enr on day.sc = enr.sc where right(enr.yr,2) = @yr and enr.sc = att.sc and enr.sn = att.sn and enr.del = 0 and day.del = 0 and dt between @SinceWhen and @UntilWhen and day.ho not in ('@','#','$'))
and dt in (
case 
when loc.ab = 1 and mst.dy = 'A-DAYS' then (select dt from day where ab = 'A' and dt = att.dt and sc = att.sc and del = 0) 
when loc.ab = 1 and mst.dy = 'B-DAYS' then (select dt from day where ab = 'B' and dt = att.dt and sc = att.sc and del = 0)
when (select bl from day where sc = att.sc and dt = att.dt) like (select '%'+ cast(car.pd as varchar(1)) + '%') then dt
when (select bl from day where sc = att.sc and dt = att.dt) = '' then dt
end)
and dt in (case when loc.ab = 0 then
case 
when mst.mm = 1 and datepart ( dw, dt ) = 2 then dt
when mst.mt = 1 and datepart ( dw, dt ) = 3 then dt
when mst.mw = 1 and datepart ( dw, dt ) = 4 then dt
when mst.mr = 1 and datepart ( dw, dt ) = 5 then dt
when mst.mf = 1 and datepart ( dw, dt ) = 6 then dt
else null end
else dt
end)
and dt between @SinceWhen and @UntilWhen) Tardies
,(select count(dt) from day where sc = car.sc and dt between car.ds and car.de and ho not in ('@','#','$') and del = 0
and dt in (
case 
when loc.ab = 1 and mst.dy = 'A-DAYS' then (select dt from day d where ab = 'A' and dt = day.dt and sc = car.sc and del = 0) 
when loc.ab = 1 and mst.dy = 'B-DAYS' then (select dt from day d where ab = 'B' and dt = day.dt and sc = car.sc and del = 0)
when (select bl from day d where sc = stu.sc and dt = day.dt) like (select '%'+ cast(car.pd as varchar(1)) + '%') then dt
when (select bl from day d where sc = stu.sc and dt = day.dt) = '' then dt
end)
and dt in (case when loc.ab = 0 then
case 
when mst.mm = 1 and datepart ( dw, dt ) = 2 then dt
when mst.mt = 1 and datepart ( dw, dt ) = 3 then dt
when mst.mw = 1 and datepart ( dw, dt ) = 4 then dt
when mst.mr = 1 and datepart ( dw, dt ) = 5 then dt
when mst.mf = 1 and datepart ( dw, dt ) = 6 then dt
else null end
else dt
end) and dt between @SinceWhen and @UntilWhen) EnrolledInCAR

from loc inner join stu on loc.cd = stu.sc
inner join car on stu.sc = car.sc and stu.sn = car.sn
inner join crs on car.cn = crs.cn
inner join tch on car.sc = tch.sc and car.tn = tch.tn
inner join mst on car.sc = mst.sc and car.se = mst.se

where loc.del = 0 and stu.del = 0 and car.del = 0 and mst.del = 0 and tch.del = 0
and loc.a = 1
and car.pd = 1
and car.ds <= @UntilWhen

union

select stu.sc, stu.sn, stu.id, stu.fn, stu.ln, stu.gr, stu.sp, stu.tg,
mst.sm, mst.pd, crs.co, tch.te, mst.dy, crs.s1, crs.dc, car.ds, car.de
,(select count(A2) from att where sc = stu.sc and sn = stu.sn and a2 in (select cd from abs where ad = 0 and del = 0 and sc = att.sc) and att.dt between car.ds and car.de
and dt in (select day.dt from day inner join enr on day.sc = enr.sc where right(enr.yr,2) = @yr and enr.sc = att.sc and enr.sn = att.sn and enr.del = 0 and day.del = 0 and dt between @SinceWhen and @UntilWhen and day.ho not in ('@','#','$'))
and dt in (
case 
when loc.ab = 1 and mst.dy = 'A-DAYS' then (select dt from day where ab = 'A' and dt = att.dt and sc = att.sc and del = 0) 
when loc.ab = 1 and mst.dy = 'B-DAYS' then (select dt from day where ab = 'B' and dt = att.dt and sc = att.sc and del = 0)
when (select bl from day where sc = att.sc and dt = att.dt) like (select '%'+ cast(car.pd as varchar(1)) + '%') then dt
when (select bl from day where sc = att.sc and dt = att.dt) = '' then dt
end)
and dt in (case when loc.ab = 0 then
case 
when mst.mm = 1 and datepart ( dw, dt ) = 2 then dt
when mst.mt = 1 and datepart ( dw, dt ) = 3 then dt
when mst.mw = 1 and datepart ( dw, dt ) = 4 then dt
when mst.mr = 1 and datepart ( dw, dt ) = 5 then dt
when mst.mf = 1 and datepart ( dw, dt ) = 6 then dt
else null end
else dt
end)
and dt between @SinceWhen and @UntilWhen) Absences
,(select count(A2) from att where sc = stu.sc and sn = stu.sn and a2 in (select cd from abs where ty in (5,8,9) and del = 0) and att.dt between car.ds and car.de
and dt in (select day.dt from day inner join enr on day.sc = enr.sc where right(enr.yr,2) = @yr and enr.sc = att.sc and enr.sn = att.sn and enr.del = 0 and day.del = 0 and dt between @SinceWhen and @UntilWhen and day.ho not in ('@','#','$'))
and dt in (
case 
when loc.ab = 1 and mst.dy = 'A-DAYS' then (select dt from day where ab = 'A' and dt = att.dt and sc = att.sc and del = 0) 
when loc.ab = 1 and mst.dy = 'B-DAYS' then (select dt from day where ab = 'B' and dt = att.dt and sc = att.sc and del = 0)
when (select bl from day where sc = att.sc and dt = att.dt) like (select '%'+ cast(car.pd as varchar(1)) + '%') then dt
when (select bl from day where sc = att.sc and dt = att.dt) = '' then dt
end)
and dt in (case when loc.ab = 0 then
case 
when mst.mm = 1 and datepart ( dw, dt ) = 2 then dt
when mst.mt = 1 and datepart ( dw, dt ) = 3 then dt
when mst.mw = 1 and datepart ( dw, dt ) = 4 then dt
when mst.mr = 1 and datepart ( dw, dt ) = 5 then dt
when mst.mf = 1 and datepart ( dw, dt ) = 6 then dt
else null end
else dt
end)
and dt between @SinceWhen and @UntilWhen) Tardies
,(select count(dt) from day where sc = car.sc and dt between car.ds and car.de and ho not in ('@','#','$') and del = 0
and dt in (
case 
when loc.ab = 1 and mst.dy = 'A-DAYS' then (select dt from day d where ab = 'A' and dt = day.dt and sc = car.sc and del = 0) 
when loc.ab = 1 and mst.dy = 'B-DAYS' then (select dt from day d where ab = 'B' and dt = day.dt and sc = car.sc and del = 0)
when (select bl from day d where sc = stu.sc and dt = day.dt) like (select '%'+ cast(car.pd as varchar(1)) + '%') then dt
when (select bl from day d where sc = stu.sc and dt = day.dt) = '' then dt
end)
and dt in (case when loc.ab = 0 then
case 
when mst.mm = 1 and datepart ( dw, dt ) = 2 then dt
when mst.mt = 1 and datepart ( dw, dt ) = 3 then dt
when mst.mw = 1 and datepart ( dw, dt ) = 4 then dt
when mst.mr = 1 and datepart ( dw, dt ) = 5 then dt
when mst.mf = 1 and datepart ( dw, dt ) = 6 then dt
else null end
else dt
end) and dt between @SinceWhen and @UntilWhen) EnrolledInCAR

from loc inner join stu on loc.cd = stu.sc
inner join car on stu.sc = car.sc and stu.sn = car.sn
inner join crs on car.cn = crs.cn
inner join tch on car.sc = tch.sc and car.tn = tch.tn
inner join mst on car.sc = mst.sc and car.se = mst.se

where loc.del = 0 and stu.del = 0 and car.del = 0 and mst.del = 0 and tch.del = 0
and loc.a = 1
and car.pd = 2
and car.ds <= @UntilWhen

union

select stu.sc, stu.sn, stu.id, stu.fn, stu.ln, stu.gr, stu.sp, stu.tg,
mst.sm, mst.pd, crs.co, tch.te, mst.dy, crs.s1, crs.dc, car.ds, car.de
,(select count(A3) from att where sc = stu.sc and sn = stu.sn and a3 in (select cd from abs where ad = 0 and del = 0 and sc = att.sc) and att.dt between car.ds and car.de
and dt in (select day.dt from day inner join enr on day.sc = enr.sc where right(enr.yr,2) = @yr and enr.sc = att.sc and enr.sn = att.sn and enr.del = 0 and day.del = 0 and dt between @SinceWhen and @UntilWhen and day.ho not in ('@','#','$'))
and dt in (
case 
when loc.ab = 1 and mst.dy = 'A-DAYS' then (select dt from day where ab = 'A' and dt = att.dt and sc = att.sc and del = 0) 
when loc.ab = 1 and mst.dy = 'B-DAYS' then (select dt from day where ab = 'B' and dt = att.dt and sc = att.sc and del = 0)
when (select bl from day where sc = att.sc and dt = att.dt) like (select '%'+ cast(car.pd as varchar(1)) + '%') then dt
when (select bl from day where sc = att.sc and dt = att.dt) = '' then dt
end)
and dt in (case when loc.ab = 0 then
case 
when mst.mm = 1 and datepart ( dw, dt ) = 2 then dt
when mst.mt = 1 and datepart ( dw, dt ) = 3 then dt
when mst.mw = 1 and datepart ( dw, dt ) = 4 then dt
when mst.mr = 1 and datepart ( dw, dt ) = 5 then dt
when mst.mf = 1 and datepart ( dw, dt ) = 6 then dt
else null end
else dt
end)
and dt between @SinceWhen and @UntilWhen) Absences
,(select count(A3) from att where sc = stu.sc and sn = stu.sn and a3 in (select cd from abs where ty in (5,8,9) and del = 0) and att.dt between car.ds and car.de
and dt in (select day.dt from day inner join enr on day.sc = enr.sc where right(enr.yr,2) = @yr and enr.sc = att.sc and enr.sn = att.sn and enr.del = 0 and day.del = 0 and dt between @SinceWhen and @UntilWhen and day.ho not in ('@','#','$'))
and dt in (
case 
when loc.ab = 1 and mst.dy = 'A-DAYS' then (select dt from day where ab = 'A' and dt = att.dt and sc = att.sc and del = 0) 
when loc.ab = 1 and mst.dy = 'B-DAYS' then (select dt from day where ab = 'B' and dt = att.dt and sc = att.sc and del = 0)
when (select bl from day where sc = att.sc and dt = att.dt) like (select '%'+ cast(car.pd as varchar(1)) + '%') then dt
when (select bl from day where sc = att.sc and dt = att.dt) = '' then dt
end)
and dt in (case when loc.ab = 0 then
case 
when mst.mm = 1 and datepart ( dw, dt ) = 2 then dt
when mst.mt = 1 and datepart ( dw, dt ) = 3 then dt
when mst.mw = 1 and datepart ( dw, dt ) = 4 then dt
when mst.mr = 1 and datepart ( dw, dt ) = 5 then dt
when mst.mf = 1 and datepart ( dw, dt ) = 6 then dt
else null end
else dt
end)
and dt between @SinceWhen and @UntilWhen) Tardies
,(select count(dt) from day where sc = car.sc and dt between car.ds and car.de and ho not in ('@','#','$') and del = 0
and dt in (
case 
when loc.ab = 1 and mst.dy = 'A-DAYS' then (select dt from day d where ab = 'A' and dt = day.dt and sc = car.sc and del = 0) 
when loc.ab = 1 and mst.dy = 'B-DAYS' then (select dt from day d where ab = 'B' and dt = day.dt and sc = car.sc and del = 0)
when (select bl from day d where sc = stu.sc and dt = day.dt) like (select '%'+ cast(car.pd as varchar(1)) + '%') then dt
when (select bl from day d where sc = stu.sc and dt = day.dt) = '' then dt
end)
and dt in (case when loc.ab = 0 then
case 
when mst.mm = 1 and datepart ( dw, dt ) = 2 then dt
when mst.mt = 1 and datepart ( dw, dt ) = 3 then dt
when mst.mw = 1 and datepart ( dw, dt ) = 4 then dt
when mst.mr = 1 and datepart ( dw, dt ) = 5 then dt
when mst.mf = 1 and datepart ( dw, dt ) = 6 then dt
else null end
else dt
end) and dt between @SinceWhen and @UntilWhen) EnrolledInCAR

from loc inner join stu on loc.cd = stu.sc
inner join car on stu.sc = car.sc and stu.sn = car.sn
inner join crs on car.cn = crs.cn
inner join tch on car.sc = tch.sc and car.tn = tch.tn
inner join mst on car.sc = mst.sc and car.se = mst.se

where loc.del = 0 and stu.del = 0 and car.del = 0 and mst.del = 0 and tch.del = 0
and loc.a = 1
and car.pd = 3
and car.ds <= @UntilWhen

union

select stu.sc, stu.sn, stu.id, stu.fn, stu.ln, stu.gr, stu.sp, stu.tg,
mst.sm, mst.pd, crs.co, tch.te, mst.dy, crs.s1, crs.dc, car.ds, car.de
,(select count(A4) from att where sc = stu.sc and sn = stu.sn and a4 in (select cd from abs where ad = 0 and del = 0 and sc = att.sc) and att.dt between car.ds and car.de
and dt in (select day.dt from day inner join enr on day.sc = enr.sc where right(enr.yr,2) = @yr and enr.sc = att.sc and enr.sn = att.sn and enr.del = 0 and day.del = 0 and dt between @SinceWhen and @UntilWhen and day.ho not in ('@','#','$'))
and dt in (
case 
when loc.ab = 1 and mst.dy = 'A-DAYS' then (select dt from day where ab = 'A' and dt = att.dt and sc = att.sc and del = 0) 
when loc.ab = 1 and mst.dy = 'B-DAYS' then (select dt from day where ab = 'B' and dt = att.dt and sc = att.sc and del = 0)
when (select bl from day where sc = att.sc and dt = att.dt) like (select '%'+ cast(car.pd as varchar(1)) + '%') then dt
when (select bl from day where sc = att.sc and dt = att.dt) = '' then dt
end)
and dt in (case when loc.ab = 0 then
case 
when mst.mm = 1 and datepart ( dw, dt ) = 2 then dt
when mst.mt = 1 and datepart ( dw, dt ) = 3 then dt
when mst.mw = 1 and datepart ( dw, dt ) = 4 then dt
when mst.mr = 1 and datepart ( dw, dt ) = 5 then dt
when mst.mf = 1 and datepart ( dw, dt ) = 6 then dt
else null end
else dt
end)
and dt between @SinceWhen and @UntilWhen) Absences
,(select count(A4) from att where sc = stu.sc and sn = stu.sn and a4 in (select cd from abs where ty in (5,8,9) and del = 0) and att.dt between car.ds and car.de
and dt in (select day.dt from day inner join enr on day.sc = enr.sc where right(enr.yr,2) = @yr and enr.sc = att.sc and enr.sn = att.sn and enr.del = 0 and day.del = 0 and dt between @SinceWhen and @UntilWhen and day.ho not in ('@','#','$'))
and dt in (
case 
when loc.ab = 1 and mst.dy = 'A-DAYS' then (select dt from day where ab = 'A' and dt = att.dt and sc = att.sc and del = 0) 
when loc.ab = 1 and mst.dy = 'B-DAYS' then (select dt from day where ab = 'B' and dt = att.dt and sc = att.sc and del = 0)
when (select bl from day where sc = att.sc and dt = att.dt) like (select '%'+ cast(car.pd as varchar(1)) + '%') then dt
when (select bl from day where sc = att.sc and dt = att.dt) = '' then dt
end)
and dt in (case when loc.ab = 0 then
case 
when mst.mm = 1 and datepart ( dw, dt ) = 2 then dt
when mst.mt = 1 and datepart ( dw, dt ) = 3 then dt
when mst.mw = 1 and datepart ( dw, dt ) = 4 then dt
when mst.mr = 1 and datepart ( dw, dt ) = 5 then dt
when mst.mf = 1 and datepart ( dw, dt ) = 6 then dt
else null end
else dt
end)
and dt between @SinceWhen and @UntilWhen) Tardies
,(select count(dt) from day where sc = car.sc and dt between car.ds and car.de and ho not in ('@','#','$') and del = 0
and dt in (
case 
when loc.ab = 1 and mst.dy = 'A-DAYS' then (select dt from day d where ab = 'A' and dt = day.dt and sc = car.sc and del = 0) 
when loc.ab = 1 and mst.dy = 'B-DAYS' then (select dt from day d where ab = 'B' and dt = day.dt and sc = car.sc and del = 0)
when (select bl from day d where sc = stu.sc and dt = day.dt) like (select '%'+ cast(car.pd as varchar(1)) + '%') then dt
when (select bl from day d where sc = stu.sc and dt = day.dt) = '' then dt
end)
and dt in (case when loc.ab = 0 then
case 
when mst.mm = 1 and datepart ( dw, dt ) = 2 then dt
when mst.mt = 1 and datepart ( dw, dt ) = 3 then dt
when mst.mw = 1 and datepart ( dw, dt ) = 4 then dt
when mst.mr = 1 and datepart ( dw, dt ) = 5 then dt
when mst.mf = 1 and datepart ( dw, dt ) = 6 then dt
else null end
else dt
end) and dt between @SinceWhen and @UntilWhen) EnrolledInCAR

from loc inner join stu on loc.cd = stu.sc
inner join car on stu.sc = car.sc and stu.sn = car.sn
inner join crs on car.cn = crs.cn
inner join tch on car.sc = tch.sc and car.tn = tch.tn
inner join mst on car.sc = mst.sc and car.se = mst.se

where loc.del = 0 and stu.del = 0 and car.del = 0 and mst.del = 0 and tch.del = 0
and loc.a = 1
and car.pd = 4
and car.ds <= @UntilWhen

union

select stu.sc, stu.sn, stu.id, stu.fn, stu.ln, stu.gr, stu.sp, stu.tg,
mst.sm, mst.pd, crs.co, tch.te, mst.dy, crs.s1, crs.dc, car.ds, car.de
,(select count(A5) from att where sc = stu.sc and sn = stu.sn and a5 in (select cd from abs where ad = 0 and del = 0 and sc = att.sc) and att.dt between car.ds and car.de
and dt in (select day.dt from day inner join enr on day.sc = enr.sc where right(enr.yr,2) = @yr and enr.sc = att.sc and enr.sn = att.sn and enr.del = 0 and day.del = 0 and dt between @SinceWhen and @UntilWhen and day.ho not in ('@','#','$'))
and dt in (
case 
when loc.ab = 1 and mst.dy = 'A-DAYS' then (select dt from day where ab = 'A' and dt = att.dt and sc = att.sc and del = 0) 
when loc.ab = 1 and mst.dy = 'B-DAYS' then (select dt from day where ab = 'B' and dt = att.dt and sc = att.sc and del = 0)
when (select bl from day where sc = att.sc and dt = att.dt) like (select '%'+ cast(car.pd as varchar(1)) + '%') then dt
when (select bl from day where sc = att.sc and dt = att.dt) = '' then dt
end)
and dt in (case when loc.ab = 0 then
case 
when mst.mm = 1 and datepart ( dw, dt ) = 2 then dt
when mst.mt = 1 and datepart ( dw, dt ) = 3 then dt
when mst.mw = 1 and datepart ( dw, dt ) = 4 then dt
when mst.mr = 1 and datepart ( dw, dt ) = 5 then dt
when mst.mf = 1 and datepart ( dw, dt ) = 6 then dt
else null end
else dt
end)
and dt between @SinceWhen and @UntilWhen) Absences
,(select count(A5) from att where sc = stu.sc and sn = stu.sn and a5 in (select cd from abs where ty in (5,8,9) and del = 0) and att.dt between car.ds and car.de
and dt in (select day.dt from day inner join enr on day.sc = enr.sc where right(enr.yr,2) = @yr and enr.sc = att.sc and enr.sn = att.sn and enr.del = 0 and day.del = 0 and dt between @SinceWhen and @UntilWhen and day.ho not in ('@','#','$'))
and dt in (
case 
when loc.ab = 1 and mst.dy = 'A-DAYS' then (select dt from day where ab = 'A' and dt = att.dt and sc = att.sc and del = 0) 
when loc.ab = 1 and mst.dy = 'B-DAYS' then (select dt from day where ab = 'B' and dt = att.dt and sc = att.sc and del = 0)
when (select bl from day where sc = att.sc and dt = att.dt) like (select '%'+ cast(car.pd as varchar(1)) + '%') then dt
when (select bl from day where sc = att.sc and dt = att.dt) = '' then dt
end)
and dt in (case when loc.ab = 0 then
case 
when mst.mm = 1 and datepart ( dw, dt ) = 2 then dt
when mst.mt = 1 and datepart ( dw, dt ) = 3 then dt
when mst.mw = 1 and datepart ( dw, dt ) = 4 then dt
when mst.mr = 1 and datepart ( dw, dt ) = 5 then dt
when mst.mf = 1 and datepart ( dw, dt ) = 6 then dt
else null end
else dt
end)
and dt between @SinceWhen and @UntilWhen) Tardies
,(select count(dt) from day where sc = car.sc and dt between car.ds and car.de and ho not in ('@','#','$') and del = 0
and dt in (
case 
when loc.ab = 1 and mst.dy = 'A-DAYS' then (select dt from day d where ab = 'A' and dt = day.dt and sc = car.sc and del = 0) 
when loc.ab = 1 and mst.dy = 'B-DAYS' then (select dt from day d where ab = 'B' and dt = day.dt and sc = car.sc and del = 0)
when (select bl from day d where sc = stu.sc and dt = day.dt) like (select '%'+ cast(car.pd as varchar(1)) + '%') then dt
when (select bl from day d where sc = stu.sc and dt = day.dt) = '' then dt
end)
and dt in (case when loc.ab = 0 then
case 
when mst.mm = 1 and datepart ( dw, dt ) = 2 then dt
when mst.mt = 1 and datepart ( dw, dt ) = 3 then dt
when mst.mw = 1 and datepart ( dw, dt ) = 4 then dt
when mst.mr = 1 and datepart ( dw, dt ) = 5 then dt
when mst.mf = 1 and datepart ( dw, dt ) = 6 then dt
else null end
else dt
end) and dt between @SinceWhen and @UntilWhen) EnrolledInCAR

from loc inner join stu on loc.cd = stu.sc
inner join car on stu.sc = car.sc and stu.sn = car.sn
inner join crs on car.cn = crs.cn
inner join tch on car.sc = tch.sc and car.tn = tch.tn
inner join mst on car.sc = mst.sc and car.se = mst.se

where loc.del = 0 and stu.del = 0 and car.del = 0 and mst.del = 0 and tch.del = 0
and loc.a = 1
and car.pd = 5
and car.ds <= @UntilWhen

union

select stu.sc, stu.sn, stu.id, stu.fn, stu.ln, stu.gr, stu.sp, stu.tg,
mst.sm, mst.pd, crs.co, tch.te, mst.dy, crs.s1, crs.dc, car.ds, car.de
,(select count(A6) from att where sc = stu.sc and sn = stu.sn and a6 in (select cd from abs where ad = 0 and del = 0 and sc = att.sc) and att.dt between car.ds and car.de
and dt in (select day.dt from day inner join enr on day.sc = enr.sc where right(enr.yr,2) = @yr and enr.sc = att.sc and enr.sn = att.sn and enr.del = 0 and day.del = 0 and dt between @SinceWhen and @UntilWhen and day.ho not in ('@','#','$'))
and dt in (
case 
when loc.ab = 1 and mst.dy = 'A-DAYS' then (select dt from day where ab = 'A' and dt = att.dt and sc = att.sc and del = 0) 
when loc.ab = 1 and mst.dy = 'B-DAYS' then (select dt from day where ab = 'B' and dt = att.dt and sc = att.sc and del = 0)
when (select bl from day where sc = att.sc and dt = att.dt) like (select '%'+ cast(car.pd as varchar(1)) + '%') then dt
when (select bl from day where sc = att.sc and dt = att.dt) = '' then dt
end)
and dt in (case when loc.ab = 0 then
case 
when mst.mm = 1 and datepart ( dw, dt ) = 2 then dt
when mst.mt = 1 and datepart ( dw, dt ) = 3 then dt
when mst.mw = 1 and datepart ( dw, dt ) = 4 then dt
when mst.mr = 1 and datepart ( dw, dt ) = 5 then dt
when mst.mf = 1 and datepart ( dw, dt ) = 6 then dt
else null end
else dt
end)
and dt between @SinceWhen and @UntilWhen) Absences
,(select count(A6) from att where sc = stu.sc and sn = stu.sn and a6 in (select cd from abs where ty in (5,8,9) and del = 0) and att.dt between car.ds and car.de
and dt in (select day.dt from day inner join enr on day.sc = enr.sc where right(enr.yr,2) = @yr and enr.sc = att.sc and enr.sn = att.sn and enr.del = 0 and day.del = 0 and dt between @SinceWhen and @UntilWhen and day.ho not in ('@','#','$'))
and dt in (
case 
when loc.ab = 1 and mst.dy = 'A-DAYS' then (select dt from day where ab = 'A' and dt = att.dt and sc = att.sc and del = 0) 
when loc.ab = 1 and mst.dy = 'B-DAYS' then (select dt from day where ab = 'B' and dt = att.dt and sc = att.sc and del = 0)
when (select bl from day where sc = att.sc and dt = att.dt) like (select '%'+ cast(car.pd as varchar(1)) + '%') then dt
when (select bl from day where sc = att.sc and dt = att.dt) = '' then dt
end)
and dt in (case when loc.ab = 0 then
case 
when mst.mm = 1 and datepart ( dw, dt ) = 2 then dt
when mst.mt = 1 and datepart ( dw, dt ) = 3 then dt
when mst.mw = 1 and datepart ( dw, dt ) = 4 then dt
when mst.mr = 1 and datepart ( dw, dt ) = 5 then dt
when mst.mf = 1 and datepart ( dw, dt ) = 6 then dt
else null end
else dt
end)
and dt between @SinceWhen and @UntilWhen) Tardies
,(select count(dt) from day where sc = car.sc and dt between car.ds and car.de and ho not in ('@','#','$') and del = 0
and dt in (
case 
when loc.ab = 1 and mst.dy = 'A-DAYS' then (select dt from day d where ab = 'A' and dt = day.dt and sc = car.sc and del = 0) 
when loc.ab = 1 and mst.dy = 'B-DAYS' then (select dt from day d where ab = 'B' and dt = day.dt and sc = car.sc and del = 0)
when (select bl from day d where sc = stu.sc and dt = day.dt) like (select '%'+ cast(car.pd as varchar(1)) + '%') then dt
when (select bl from day d where sc = stu.sc and dt = day.dt) = '' then dt
end)
and dt in (case when loc.ab = 0 then
case 
when mst.mm = 1 and datepart ( dw, dt ) = 2 then dt
when mst.mt = 1 and datepart ( dw, dt ) = 3 then dt
when mst.mw = 1 and datepart ( dw, dt ) = 4 then dt
when mst.mr = 1 and datepart ( dw, dt ) = 5 then dt
when mst.mf = 1 and datepart ( dw, dt ) = 6 then dt
else null end
else dt
end) and dt between @SinceWhen and @UntilWhen) EnrolledInCAR

from loc inner join stu on loc.cd = stu.sc
inner join car on stu.sc = car.sc and stu.sn = car.sn
inner join crs on car.cn = crs.cn
inner join tch on car.sc = tch.sc and car.tn = tch.tn
inner join mst on car.sc = mst.sc and car.se = mst.se

where loc.del = 0 and stu.del = 0 and car.del = 0 and mst.del = 0 and tch.del = 0
and loc.a = 1
and car.pd = 6
and car.ds <= @UntilWhen

union

select stu.sc, stu.sn, stu.id, stu.fn, stu.ln, stu.gr, stu.sp, stu.tg,
mst.sm, mst.pd, crs.co, tch.te, mst.dy, crs.s1, crs.dc, car.ds, car.de
,(select count(A7) from att where sc = stu.sc and sn = stu.sn and a7 in (select cd from abs where ad = 0 and del = 0 and sc = att.sc) and att.dt between car.ds and car.de
and dt in (select day.dt from day inner join enr on day.sc = enr.sc where right(enr.yr,2) = @yr and enr.sc = att.sc and enr.sn = att.sn and enr.del = 0 and day.del = 0 and dt between @SinceWhen and @UntilWhen and day.ho not in ('@','#','$'))
and dt in (
case 
when loc.ab = 1 and mst.dy = 'A-DAYS' then (select dt from day where ab = 'A' and dt = att.dt and sc = att.sc and del = 0) 
when loc.ab = 1 and mst.dy = 'B-DAYS' then (select dt from day where ab = 'B' and dt = att.dt and sc = att.sc and del = 0)
when (select bl from day where sc = att.sc and dt = att.dt) like (select '%'+ cast(car.pd as varchar(1)) + '%') then dt
when (select bl from day where sc = att.sc and dt = att.dt) = '' then dt
end)
and dt in (case when loc.ab = 0 then
case 
when mst.mm = 1 and datepart ( dw, dt ) = 2 then dt
when mst.mt = 1 and datepart ( dw, dt ) = 3 then dt
when mst.mw = 1 and datepart ( dw, dt ) = 4 then dt
when mst.mr = 1 and datepart ( dw, dt ) = 5 then dt
when mst.mf = 1 and datepart ( dw, dt ) = 6 then dt
else null end
else dt
end)
and dt between @SinceWhen and @UntilWhen) Absences
,(select count(A7) from att where sc = stu.sc and sn = stu.sn and a7 in (select cd from abs where ty in (5,8,9) and del = 0) and att.dt between car.ds and car.de
and dt in (select day.dt from day inner join enr on day.sc = enr.sc where right(enr.yr,2) = @yr and enr.sc = att.sc and enr.sn = att.sn and enr.del = 0 and day.del = 0 and dt between @SinceWhen and @UntilWhen and day.ho not in ('@','#','$'))
and dt in (
case 
when loc.ab = 1 and mst.dy = 'A-DAYS' then (select dt from day where ab = 'A' and dt = att.dt and sc = att.sc and del = 0) 
when loc.ab = 1 and mst.dy = 'B-DAYS' then (select dt from day where ab = 'B' and dt = att.dt and sc = att.sc and del = 0)
when (select bl from day where sc = att.sc and dt = att.dt) like (select '%'+ cast(car.pd as varchar(1)) + '%') then dt
when (select bl from day where sc = att.sc and dt = att.dt) = '' then dt
end)
and dt in (case when loc.ab = 0 then
case 
when mst.mm = 1 and datepart ( dw, dt ) = 2 then dt
when mst.mt = 1 and datepart ( dw, dt ) = 3 then dt
when mst.mw = 1 and datepart ( dw, dt ) = 4 then dt
when mst.mr = 1 and datepart ( dw, dt ) = 5 then dt
when mst.mf = 1 and datepart ( dw, dt ) = 6 then dt
else null end
else dt
end)
and dt between @SinceWhen and @UntilWhen) Tardies
,(select count(dt) from day where sc = car.sc and dt between car.ds and car.de and ho not in ('@','#','$') and del = 0
and dt in (
case 
when loc.ab = 1 and mst.dy = 'A-DAYS' then (select dt from day d where ab = 'A' and dt = day.dt and sc = car.sc and del = 0) 
when loc.ab = 1 and mst.dy = 'B-DAYS' then (select dt from day d where ab = 'B' and dt = day.dt and sc = car.sc and del = 0)
when (select bl from day d where sc = stu.sc and dt = day.dt) like (select '%'+ cast(car.pd as varchar(1)) + '%') then dt
when (select bl from day d where sc = stu.sc and dt = day.dt) = '' then dt
end)
and dt in (case when loc.ab = 0 then
case 
when mst.mm = 1 and datepart ( dw, dt ) = 2 then dt
when mst.mt = 1 and datepart ( dw, dt ) = 3 then dt
when mst.mw = 1 and datepart ( dw, dt ) = 4 then dt
when mst.mr = 1 and datepart ( dw, dt ) = 5 then dt
when mst.mf = 1 and datepart ( dw, dt ) = 6 then dt
else null end
else dt
end) and dt between @SinceWhen and @UntilWhen) EnrolledInCAR

from loc inner join stu on loc.cd = stu.sc
inner join car on stu.sc = car.sc and stu.sn = car.sn
inner join crs on car.cn = crs.cn
inner join tch on car.sc = tch.sc and car.tn = tch.tn
inner join mst on car.sc = mst.sc and car.se = mst.se

where loc.del = 0 and stu.del = 0 and car.del = 0 and mst.del = 0 and tch.del = 0
and loc.a = 1
and car.pd = 7
and car.ds <= @UntilWhen

union

select stu.sc, stu.sn, stu.id, stu.fn, stu.ln, stu.gr, stu.sp, stu.tg,
mst.sm, mst.pd, crs.co, tch.te, mst.dy, crs.s1, crs.dc, car.ds, car.de
,(select count(A8) from att where sc = stu.sc and sn = stu.sn and a8 in (select cd from abs where ad = 0 and del = 0 and sc = att.sc) and att.dt between car.ds and car.de
and dt in (select day.dt from day inner join enr on day.sc = enr.sc where right(enr.yr,2) = @yr and enr.sc = att.sc and enr.sn = att.sn and enr.del = 0 and day.del = 0 and dt between @SinceWhen and @UntilWhen and day.ho not in ('@','#','$'))
and dt in (
case 
when loc.ab = 1 and mst.dy = 'A-DAYS' then (select dt from day where ab = 'A' and dt = att.dt and sc = att.sc and del = 0) 
when loc.ab = 1 and mst.dy = 'B-DAYS' then (select dt from day where ab = 'B' and dt = att.dt and sc = att.sc and del = 0)
when (select bl from day where sc = att.sc and dt = att.dt) like (select '%'+ cast(car.pd as varchar(1)) + '%') then dt
when (select bl from day where sc = att.sc and dt = att.dt) = '' then dt
end)
and dt in (case when loc.ab = 0 then
case 
when mst.mm = 1 and datepart ( dw, dt ) = 2 then dt
when mst.mt = 1 and datepart ( dw, dt ) = 3 then dt
when mst.mw = 1 and datepart ( dw, dt ) = 4 then dt
when mst.mr = 1 and datepart ( dw, dt ) = 5 then dt
when mst.mf = 1 and datepart ( dw, dt ) = 6 then dt
else null end
else dt
end)
and dt between @SinceWhen and @UntilWhen) Absences
,(select count(A8) from att where sc = stu.sc and sn = stu.sn and a8 in (select cd from abs where ty in (5,8,9) and del = 0) and att.dt between car.ds and car.de
and dt in (select day.dt from day inner join enr on day.sc = enr.sc where right(enr.yr,2) = @yr and enr.sc = att.sc and enr.sn = att.sn and enr.del = 0 and day.del = 0 and dt between @SinceWhen and @UntilWhen and day.ho not in ('@','#','$'))
and dt in (
case 
when loc.ab = 1 and mst.dy = 'A-DAYS' then (select dt from day where ab = 'A' and dt = att.dt and sc = att.sc and del = 0) 
when loc.ab = 1 and mst.dy = 'B-DAYS' then (select dt from day where ab = 'B' and dt = att.dt and sc = att.sc and del = 0)
when (select bl from day where sc = att.sc and dt = att.dt) like (select '%'+ cast(car.pd as varchar(1)) + '%') then dt
when (select bl from day where sc = att.sc and dt = att.dt) = '' then dt
end)
and dt in (case when loc.ab = 0 then
case 
when mst.mm = 1 and datepart ( dw, dt ) = 2 then dt
when mst.mt = 1 and datepart ( dw, dt ) = 3 then dt
when mst.mw = 1 and datepart ( dw, dt ) = 4 then dt
when mst.mr = 1 and datepart ( dw, dt ) = 5 then dt
when mst.mf = 1 and datepart ( dw, dt ) = 6 then dt
else null end
else dt
end)
and dt between @SinceWhen and @UntilWhen) Tardies
,(select count(dt) from day where sc = car.sc and dt between car.ds and car.de and ho not in ('@','#','$') and del = 0
and dt in (
case 
when loc.ab = 1 and mst.dy = 'A-DAYS' then (select dt from day d where ab = 'A' and dt = day.dt and sc = car.sc and del = 0) 
when loc.ab = 1 and mst.dy = 'B-DAYS' then (select dt from day d where ab = 'B' and dt = day.dt and sc = car.sc and del = 0)
when (select bl from day d where sc = stu.sc and dt = day.dt) like (select '%'+ cast(car.pd as varchar(1)) + '%') then dt
when (select bl from day d where sc = stu.sc and dt = day.dt) = '' then dt
end)
and dt in (case when loc.ab = 0 then
case 
when mst.mm = 1 and datepart ( dw, dt ) = 2 then dt
when mst.mt = 1 and datepart ( dw, dt ) = 3 then dt
when mst.mw = 1 and datepart ( dw, dt ) = 4 then dt
when mst.mr = 1 and datepart ( dw, dt ) = 5 then dt
when mst.mf = 1 and datepart ( dw, dt ) = 6 then dt
else null end
else dt
end) and dt between @SinceWhen and @UntilWhen) EnrolledInCAR

from loc inner join stu on loc.cd = stu.sc
inner join car on stu.sc = car.sc and stu.sn = car.sn
inner join crs on car.cn = crs.cn
inner join tch on car.sc = tch.sc and car.tn = tch.tn
inner join mst on car.sc = mst.sc and car.se = mst.se

where loc.del = 0 and stu.del = 0 and car.del = 0 and mst.del = 0 and tch.del = 0
and loc.a = 1
and car.pd = 8
and car.ds <= @UntilWhen

union

select stu.sc, stu.sn, stu.id, stu.fn, stu.ln, stu.gr, stu.sp, stu.tg,
mst.sm, mst.pd, crs.co, tch.te, mst.dy, crs.s1, crs.dc, car.ds, car.de
,(select count(A9) from att where sc = stu.sc and sn = stu.sn and a9 in (select cd from abs where ad = 0 and del = 0 and sc = att.sc) and att.dt between car.ds and car.de
and dt in (select day.dt from day inner join enr on day.sc = enr.sc where right(enr.yr,2) = @yr and enr.sc = att.sc and enr.sn = att.sn and enr.del = 0 and day.del = 0 and dt between @SinceWhen and @UntilWhen and day.ho not in ('@','#','$'))
and dt in (
case 
when loc.ab = 1 and mst.dy = 'A-DAYS' then (select dt from day where ab = 'A' and dt = att.dt and sc = att.sc and del = 0) 
when loc.ab = 1 and mst.dy = 'B-DAYS' then (select dt from day where ab = 'B' and dt = att.dt and sc = att.sc and del = 0)
when (select bl from day where sc = att.sc and dt = att.dt) like (select '%'+ cast(car.pd as varchar(1)) + '%') then dt
when (select bl from day where sc = att.sc and dt = att.dt) = '' then dt
end)
and dt in (case when loc.ab = 0 then
case 
when mst.mm = 1 and datepart ( dw, dt ) = 2 then dt
when mst.mt = 1 and datepart ( dw, dt ) = 3 then dt
when mst.mw = 1 and datepart ( dw, dt ) = 4 then dt
when mst.mr = 1 and datepart ( dw, dt ) = 5 then dt
when mst.mf = 1 and datepart ( dw, dt ) = 6 then dt
else null end
else dt
end)
and dt between @SinceWhen and @UntilWhen) Absences
,(select count(A9) from att where sc = stu.sc and sn = stu.sn and a9 in (select cd from abs where ty in (5,8,9) and del = 0) and att.dt between car.ds and car.de
and dt in (select day.dt from day inner join enr on day.sc = enr.sc where right(enr.yr,2) = @yr and enr.sc = att.sc and enr.sn = att.sn and enr.del = 0 and day.del = 0 and dt between @SinceWhen and @UntilWhen and day.ho not in ('@','#','$'))
and dt in (
case 
when loc.ab = 1 and mst.dy = 'A-DAYS' then (select dt from day where ab = 'A' and dt = att.dt and sc = att.sc and del = 0) 
when loc.ab = 1 and mst.dy = 'B-DAYS' then (select dt from day where ab = 'B' and dt = att.dt and sc = att.sc and del = 0)
when (select bl from day where sc = att.sc and dt = att.dt) like (select '%'+ cast(car.pd as varchar(1)) + '%') then dt
when (select bl from day where sc = att.sc and dt = att.dt) = '' then dt
end)
and dt in (case when loc.ab = 0 then
case 
when mst.mm = 1 and datepart ( dw, dt ) = 2 then dt
when mst.mt = 1 and datepart ( dw, dt ) = 3 then dt
when mst.mw = 1 and datepart ( dw, dt ) = 4 then dt
when mst.mr = 1 and datepart ( dw, dt ) = 5 then dt
when mst.mf = 1 and datepart ( dw, dt ) = 6 then dt
else null end
else dt
end)
and dt between @SinceWhen and @UntilWhen) Tardies
,(select count(dt) from day where sc = car.sc and dt between car.ds and car.de and ho not in ('@','#','$') and del = 0
and dt in (
case 
when loc.ab = 1 and mst.dy = 'A-DAYS' then (select dt from day d where ab = 'A' and dt = day.dt and sc = car.sc and del = 0) 
when loc.ab = 1 and mst.dy = 'B-DAYS' then (select dt from day d where ab = 'B' and dt = day.dt and sc = car.sc and del = 0)
when (select bl from day d where sc = stu.sc and dt = day.dt) like (select '%'+ cast(car.pd as varchar(1)) + '%') then dt
when (select bl from day d where sc = stu.sc and dt = day.dt) = '' then dt
end)
and dt in (case when loc.ab = 0 then
case 
when mst.mm = 1 and datepart ( dw, dt ) = 2 then dt
when mst.mt = 1 and datepart ( dw, dt ) = 3 then dt
when mst.mw = 1 and datepart ( dw, dt ) = 4 then dt
when mst.mr = 1 and datepart ( dw, dt ) = 5 then dt
when mst.mf = 1 and datepart ( dw, dt ) = 6 then dt
else null end
else dt
end) and dt between @SinceWhen and @UntilWhen) EnrolledInCAR

from loc inner join stu on loc.cd = stu.sc
inner join car on stu.sc = car.sc and stu.sn = car.sn
inner join crs on car.cn = crs.cn
inner join tch on car.sc = tch.sc and car.tn = tch.tn
inner join mst on car.sc = mst.sc and car.se = mst.se

where loc.del = 0 and stu.del = 0 and car.del = 0 and mst.del = 0 and tch.del = 0
and loc.a = 1
and car.pd = 9
and car.ds <= @UntilWhen
) TardyPresent

) GroupedCAR --some students bounce into the same section more than once

where sc = $sc and 
EnrolledInCAR > 0
group by sc, sn, id, fn, ln, gr, sp, tg, sm, pd, co, te, dy, s1, dc
order by sc, ln, fn, sm, pd



" | Export-Csv $OutPath\PERIOD_ATT_PERCENTAGE.csv -NoTypeInformation

